/*------------------------------------------------------------------------------
--       Copyright (c) 2015-2017, VeriSilicon Inc. All rights reserved        --
--         Copyright (c) 2011-2014, Google Inc. All rights reserved.          --
--         Copyright (c) 2007-2010, Hantro OY. All rights reserved.           --
--                                                                            --
-- This software is confidential and proprietary and may be used only as      --
--   expressly authorized by VeriSilicon in a written licensing agreement.    --
--                                                                            --
--         This entire notice must be reproduced on all copies                --
--                       and may not be removed.                              --
--                                                                            --
--------------------------------------------------------------------------------
-- Redistribution and use in source and binary forms, with or without         --
-- modification, are permitted provided that the following conditions are met:--
--   * Redistributions of source code must retain the above copyright notice, --
--       this list of conditions and the following disclaimer.                --
--   * Redistributions in binary form must reproduce the above copyright      --
--       notice, this list of conditions and the following disclaimer in the  --
--       documentation and/or other materials provided with the distribution. --
--   * Neither the names of Google nor the names of its contributors may be   --
--       used to endorse or promote products derived from this software       --
--       without specific prior written permission.                           --
--------------------------------------------------------------------------------
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"--
-- AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  --
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE --
-- ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE  --
-- LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        --
-- CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       --
-- SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   --
-- INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    --
-- CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    --
-- ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE --
-- POSSIBILITY OF SUCH DAMAGE.                                                --
--------------------------------------------------------------------------------
------------------------------------------------------------------------------*/

#ifndef __VSI_STRING_H__
#define __VSI_STRING_H__

#ifdef __cplusplus
extern "C" {
#endif
/*#define _USE_VSI_STRING_*/

#ifdef _USE_VSI_STRING_
#define atoi    vsi_atoi   
#define strcat  vsi_strcat 
#define strcmp  vsi_strcmp 
#define strcpy  vsi_strcpy 
#define strlen  vsi_strlen 
#define strncmp vsi_strncmp
#define strncpy vsi_strncpy
#define strtok  vsi_strtok 
#define strtol  vsi_strtol
/*#include <string.h>*/
#else
#include <string.h>
#endif

extern char *vsi_strcat (char *dest, const char *src);
extern int vsi_strcmp (const char *s1, const char *s2);
extern int vsi_strncmp (const char *s1, const char *s2, unsigned int n);
extern char *vsi_strcpy (char *dest, const char *src);
extern char *vsi_strncpy (char *dest, const char *src, unsigned int n);
extern unsigned int vsi_strlen (const char *s);
extern char *vsi_strtok (char *s, const char *delim);
long int vsi_strtol(const char *nptr,char **endptr,int base);
int vsi_atoi (const char *nptr);

#ifdef __cplusplus
}
#endif

#endif
